package com.njcn.gather.type.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.njcn.gather.system.dictionary.pojo.po.DictData;
import com.njcn.gather.type.pojo.param.DevTypeParam;
import com.njcn.gather.type.pojo.po.DevType;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author hongawen
 * @since 2025-01-13
 */
public interface IDevTypeService extends IService<DevType> {

    /**
     * 查询所有设备类型
     *
     * @return 所有设备类型
     */
    List<DevType> listAll();

    /**
     * 根据名称查询设备类型
     *
     * @param name 名称
     * @return
     */
    DevType getByName(String name);

    /**
     * 根据id查询设备类型
     *
     * @param id id
     * @return
     */
    DevType getById(String id);

    /**
     * 根据id列表查询设备类型
     *
     * @param ids id列表
     * @return
     */
    List<DevType> listByIds(List<String> ids);

    /**
     * 分页查询设备类型
     *
     * @param queryParam 查询参数
     * @return 分页查询结果
     */
    Page<DevType> listDevType(DevTypeParam.QueryParam queryParam);

    /**
     * 新增设备类型
     *
     * @param addParam 设备类型数据
     * @return 成功返回true，失败返回false
     */
    boolean addDevType(DevTypeParam addParam);

    /**
     * 修改设备类型
     *
     * @param updateParam 设备类型数据
     * @return 成功返回true，失败返回false
     */
    boolean updateDevType(DevTypeParam.UpdateParam updateParam);

    /**
     * 批量删除设备类型
     *
     * @param ids id列表
     * @return 成功返回true，失败返回false
     */
    boolean deleteDevType(List<String> ids);

    /**
     * 根据设备蕾西id获取报告名称
     * @param devType 设备类型Id
     * @return 报告字典
     */
    DictData getReportName(String devType);
}
